import oscP5.*; //library to receive data via OSC from the other sketch
import netP5.*;

OscP5 oscP5;

PFont Font,BFont,SFont,IFont,LFont;

float receivedX, receivedY, receivedZ;

float yLevel = 690;
float xLevel = 125;
float zDepth = 514;

PImage qrCode;

boolean isPositioned = false;


void setup(){
  size(250, 1006,P2D);
  oscP5 = new OscP5(this, 5005);
  background(0);
  smooth(4);
  strokeWeight(1);
  stroke(255);
  Font = createFont("Arial Bold", 12, true);
  BFont = createFont("Arial Black", 16, true);
  SFont = createFont("Arial Black", 12, true);
  LFont = createFont("Arial Bold", 13, true);
  IFont = createFont("Arial-BoldItalicMT", 12, true);
  qrCode = loadImage("qrCode.jpg");
}


void draw(){
  if (!isPositioned) {
    frame.setLocation(0, 0);
    isPositioned = true;
  }
  background(0);
  fill(255);
  textFont(BFont);
  textLeading(22);
  text("DEEP INTO THE ANIMAL EXTINTION", 30, 30, 200, 200);
  textFont(IFont);
  //textSize(12);
  text("14,488 species", 30, 90, 120, 200);
  stroke(255);  
  line(0,135,width,135);
  
  textFont(BFont);
  text("LEGEND", 30, 160, 120, 200);
  noStroke();
  textFont(LFont);
  fill(0,129,227); //cyan square - mammals
  rect(30, 195, 20,20);
  fill(255);
  text("Mammals", 60, 210);
  
  fill(102, 36, 131); //purple rhombus - birds
  translate(40, 225);
  rotate(radians(45)); 
  rect(0, 0, 16, 16); 
  rotate(radians(-45));
  fill(255);
  text("Birds", 20, 16);
  translate(-40, -225);
  
  fill(255, 167, 0); // orange rev triangle - amphibes
  translate(40, 269);
  triangle(-10, -10, 10, -10, 0, 8);
  fill(255);
  text("Amphibes", 20, 4);
  translate(-40, -269);
  
  fill(230, 0, 126); // pink triangle up - fishes
  translate(40,299);
  triangle(10, 10, -10, 10, 0, -8);
  fill(255);
  text("Fishes", 20,6);
  translate(-40, -299);
  
  fill(101, 179, 46); //green circle - reptile
  ellipse(40, 335, 20, 20);
  fill(255);
  text("Reptiles", 60, 340);
  
  stroke(255);
  line(0, 375, width, 375);
  
  textFont(BFont);
  text("Z AXIS MAP", 30, 420);
  textFont(Font);
  //textSize(12);
  text("Extint in the wild", 55, 440);
  text("Critically endangered", 55, 460);
  text("Endangered", 55, 480);
  text("Vulnerable", 55, 500);
  text("Data Deficency", 55, 520);
  
  fill(0);
  //strokeWeight(2);
  stroke(255);
  rect(30, 430, 15, 90);

  
  zDepth = zDepth - (receivedZ/90); 
  
  strokeWeight(2);
    
  if (zDepth<429){
    line(30, 429, 45, 429);
  }
  else if (zDepth>519){
    line(30, 519, 45, 519);
  }
  else {
    line(30, zDepth, 45, zDepth);
  }
    
  line(0, 555, width, 555);
  
  strokeWeight(1);
  
  textFont(BFont);
  fill(255);
  text("X, Y AXIS MAP", 30, 580, 150, 50);
  fill(0);
  rect(30, 610, 190, 160);
  fill(255);
   
  xLevel = xLevel + (receivedX/450); 
  yLevel = yLevel + (receivedY/450);
  
  if (xLevel<31){
    if (yLevel<610){
      rect(31, 610, 5, 5);
    }
    else if (yLevel>764){
      rect(31, 764, 5, 5);
    }
    else
      rect(31, yLevel, 5, 5);
  }
  else if (xLevel>214){
    if (yLevel<610){
      rect(214, 610, 5, 5);
    }
    else if (yLevel>764){
      rect(214, 764, 5, 5);
    }
    else 
      rect(214, yLevel, 5, 5);
  }
  else if (yLevel<610){
    rect(xLevel, 610, 5, 5);
    }
   else if (yLevel>764){
     rect(xLevel, 764, 5, 5);
   }
  else {
    rect(xLevel, yLevel, 5, 5);
  }

  line(0, 805, width, 805);
  
  textFont(BFont);
  text("COMPANION APP", 30, 825, 180, 100);
  
  //line(0, 945, width, 945);
  
  //text("INFO", 30, 965, width, 965);
  
  fill(255);
  image(qrCode, 30, 850, 140, 140);
  //rect(30,850,140,140);
  
  receivedX = 0;
  receivedY = 0;
  receivedZ = 0;
  
}

void oscEvent(OscMessage theOscMessage){
  
  if (theOscMessage.checkAddrPattern("/leapCoords")){
    //println("LEAPLEAPLEAP");
    receivedX = theOscMessage.get(0).floatValue();
    receivedY = theOscMessage.get(1).floatValue();
    receivedZ = theOscMessage.get(2).floatValue();
  }
  
  if (theOscMessage.checkAddrPattern("/reset")){
    //println("SPACEBARSPACEBARSPACEBAR");
    yLevel = 690;
    xLevel = 125;
    zDepth = 514;
    receivedX = 0;
    receivedY = 0;
    receivedZ = 0;
    
  }
}
